#!/usr/bin/ruby

# Implementar en este fichero la clase para crear objetos racionales
class Dieta 
    
    include Comparable
    
    attr_accessor :comida,:porcentaje_comida,:platos_comida,:cantidad_platos,:gr_platos,:vct,:porcentaje_proteinas,:porcentaje_grasas,:porcentaje_hidratos
    
    # Funcion de inicialización de las variables
    def initialize(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
        @comida=comida
        @porcentaje_comida=porcentaje_comida
        @platos_comida=platos_comida
        @cantidad_platos=cantidad_platos
        @gr_platos=gr_platos
        @vct=vct
        @porcentaje_proteinas=porcentaje_proteinas
        @porcentaje_grasas=porcentaje_grasas
        @porcentaje_hidratos=porcentaje_hidratos
    end 
    
    # Funcion para el comparable
    def <=> other
        vct <=> other.vct
    end
    # Funcion para obtener la comida
    def get_comida
        @comida       
    end
    # Funcion para obtener el porcentaje de la comida del dia
    def get_porcentaje_comida
        @porcentaje_comida
    end
    # Funcion para obtener los platos de comida
    def get_platos_comida
        @platos_comida
    end
    # Funcion para obtener el numero de platos
    def get_cantidad_platos
        @cantidad_platos
    end
    # Funcion para obtener los gramos de los platos
    def get_gr_platos
        @gr_platos
    end
    # Funcion para obtener el valor calorias totales
    def get_vct
        @vct
    end
    # Funcion para obtener el porcentaje de proteinas
    def get_porcentaje_proteinas
        @porcentaje_proteinas
    end
    # Funcion para obtener el porcentaje de grasas
    def get_porcentaje_grasas
        @porcentaje_grasas
    end
    # Funcion para obtener el porcentaje de hidratos
    def get_porcentaje_hidratos
        @porcentaje_hidratos
    end
    # Funcion para ordenar por gramos
    def ordenacion_gr
        @gr_platos.sort
    end
    # Funcion para mostrar el menu
    def to_s
        s="\n#{@comida} (#{@porcentaje_comida})\n"
        (0..@platos_comida.size-1).each do |i| 
            s<< "#{@platos_comida[i]}, #{@cantidad_platos[i]}, #{@gr_platos[i]}g.\n"
        end
        s<< "VCT | %\t#{@vct} kcal | #{@porcentaje_proteinas}% - #{@porcentaje_grasas}% - #{@porcentaje_hidratos}%\n"
        s
    end
   
    
end


class GrupoAlimento < Dieta

attr_reader :alimento
	
	# Funcion de inicialización de las variables 
	def initialize(alimento,comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
		@alimento = alimento
		super(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
	end
	# Funcion para mostrar el menu + el grupo de alimento
	def to_s
		aux = "#{@alimento}\n"
		super.to_s += aux
	end
end


class GrupoEdad < Dieta

attr_reader :edad
	# Funcion de inicialización de las variables 
	def initialize(edad,comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
		@edad = edad
		super(comida,porcentaje_comida,platos_comida,cantidad_platos,gr_platos,vct,porcentaje_proteinas,porcentaje_grasas,porcentaje_hidratos)
	end
	# Funcion para mostrar el menu + el grupo de edad
	def to_s
		aux = "#{@edad}\n"
		super.to_s += aux
	end
end
